Unit f2treat_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE70EC_p;

procedure F2TREA1(S :Integer; XI :Extended; XE :Extended;
                var Y :Array of Extended; var DY :Array of Extended;
                var AY :Array of Extended; var ADY :Array of Extended;
                var AD2Y :Array of Extended; M :Integer; KP1 :Integer;
                KP2 :Integer; KP3 :Integer);
procedure F2TREA2(S :Integer; XI :Extended; XE :Extended;
                var Y :Array of Extended; var DY :Array of Extended;
                var AY :Array of Extended; var ADY :Array of Extended;
                var AD2Y :Array of Extended; M :Integer;
                KP1 :Integer; KP2 :Integer; KP3 :Integer);
procedure F2TREA3(S :Integer; XI :Extended; XE :Extended;
                var Y :Array of Extended; var DY :Array of Extended;
                var AY :Array of Extended; var ADY :Array of Extended;
                var AD2Y :Array of Extended; M :Integer;
                KP1 :Integer; KP2 :Integer; KP3 :Integer);

implementation

procedure F2TREA1(S :Integer; XI :Extended; XE :Extended;
                var Y :Array of Extended; var DY :Array of Extended;
                var AY :Array of Extended; var ADY :Array of Extended;
                var AD2Y :Array of Extended; M :Integer; KP1 :Integer;
                KP2 :Integer; KP3 :Integer);
var
_i,L,J :Integer;
label
_20;
begin
_PResult := _PResult + Format(#$0D#$0A+' COEFFICIENTS AY,ADY AND AD2Y ON %3d   SEGMENT:  '+#$0D#$0A+' XI=%30.18e      XE=%30.18e ',
 [S,XI,XE]) + #$0D#$0A;
_PResult := _PResult + Format('%s',
 [' SOLUTION Y AT THE END OF THE SEGMENT [XI,XE],i.e. Y[XE-1]:' + #$0D#$0A]);
_PResult := _PResult + Format('%s',['  Y=']);
for _i:=0 to M-1 do
 begin
  _PResult := _PResult + Format('%30.18e ',[Y[_i]]);
  if ( ((_i+1) mod 2)=0 )
   then _PResult := _PResult + #$0D#$0A;
 end;
_PResult := _PResult + Format('%s',
 [#$0D#$0A + ' DERIVATIVE DY AT THE END OF THE SEGMENT [XI,XE],i.e. DY[XE-1]:' + #$0D#$0A]);
_PResult := _PResult + Format('%s',[' DY=']);
for _i:=0 to M-1 do
 begin
  _PResult := _PResult + Format('%30.18e ',[DY[_i]]);
  if ( ((_i+1) mod 2)=0 )
   then _PResult := _PResult + #$0D#$0A;
 end;
for L:=1 to M do
 begin
  _PResult := _PResult + Format(#$0D#$0A+'  Number of       Chebyshev coefficients for %1d ',
 [L]);
  _PResult := _PResult + Format('%s',
 [' component'+#$0D#$0A+'              ------------------------------------------------------------------------------'+#$0D#$0A+' coefficient           for Y                         for Y''                         for Y'''''+#$0D#$0A+' -------------------------------------------------------------------------------------------']) + #$0D#$0A;
  for J:=1 to KP1 do
   begin
    _PResult := _PResult + Format('     %2d      %30.18e %30.18e %30.18e ',[
J-1,AY[(L-1)+(J-1)*M],  ADY[(L-1)+(J-1)*M],AD2Y[(L-1)+(J-1)*M]]) + #$0D#$0A;
   end;
  _PResult := _PResult + Format('     %2d      %30.18e %30.18e  '+#$0D#$0A+'     %2d      %30.18e ',
 [KP1,AY[(L-1)+(KP2-1)*M],ADY[(L-1)+(KP2-1)*M],KP2,AY[(L-1)+(KP3-1)*M]]) + #$0D#$0A;
_20:
 end;
exit;
end;
//******************************************************************
procedure F2TREA2(S :Integer; XI :Extended; XE :Extended;
                var Y :Array of Extended; var DY :Array of Extended;
                var AY :Array of Extended; var ADY :Array of Extended;
                var AD2Y :Array of Extended; M :Integer;
                KP1 :Integer; KP2 :Integer; KP3 :Integer);
var
I :Integer;
label
_10,_15,_20,_25,_30,_35,_40,_45;
begin
{  }
{     AY1 - CHEBYSHEV COEFFICIENTS FOR 1 COORDINATE AT 1 INTERVAL }
{     AY2 - CHEBYSHEV COEFFICIENTS FOR 2 COORDINATE AT 1 INTERVAL }
{  }
{     AV1 - CHEBYSHEV COEFFICIENTS FOR 1 VELOCITY COMPONENT AT 1 INTERVAL }
{     AV2 - CHEBYSHEV COEFFICIENTS FOR 2 VELOCITY COMPONENT AT 1 INTERVAL }
{  }
{     AW1 - CHEBYSHEV COEFFICIENTS FOR 1 ACCELERATION COMPONENT AT 1 INTE }
{     AW2 - CHEBYSHEV COEFFICIENTS FOR 2 ACCELERATION COMPONENT AT 1 INTE }
{  }
{     BY1 - CHEBYSHEV COEFFICIENTS FOR 1 COORDINATE AT 2 INTERVAL }
{     BY2 - CHEBYSHEV COEFFICIENTS FOR 2 COORDINATE AT 2 INTERVAL }
{  }
{     BV1 - CHEBYSHEV COEFFICIENTS FOR 1 VELOCITY COMPONENT AT 2 INTERVAL }
{     BV2 - CHEBYSHEV COEFFICIENTS FOR 2 VELOCITY COMPONENT AT 2 INTERVAL }
{  }
{     BW1 - CHEBYSHEV COEFFICIENTS FOR 1 ACCELERATION COMPONENT AT 2 INTE }
{     BW2 - CHEBYSHEV COEFFICIENTS FOR 2 ACCELERATION COMPONENT AT 2 INTE }
{  }
{      YA - COORDINATES AT THE END OF 1 INTERVAL }
{      VA - VELOCITY    AT THE END OF 1 INTERVAL }
{  }
{      YB - COORDINATES AT THE END OF 2 INTERVAL }
{      VB - VELOCITY    AT THE END OF 2 INTERVAL }
{  }
{     INA - BOUNDARIES OF 1 INTERVAL }
{     INB - BOUNDARIES OF 2 INTERVAL }
{  }
case S of
 1: goto _10;
 2: goto _30;
end;
{  }
{ --------SAVING CHEBYSHEV COEFFICIENTS FOR  COORDINATES, }
{ --------     VELOCITY COMPONENTS AND ACCELERATION COMPONENTS }
{ ---------             AT THE FIRST INTERVAL }
{  };
_10:
for I:=1 to KP3 do
 begin
  _FIRST_SEG.elm1[I-1] := AY[(I-1)*M];
_15:
  _FIRST_SEG.elm2[I-1] := AY[1+(I-1)*M];
 end;
{  }
for I:=1 to KP2 do
 begin
  _FIRST_SEG.elm3[I-1] := ADY[(I-1)*M];
_20:
  _FIRST_SEG.elm4[I-1] := ADY[1+(I-1)*M];
 end;
{  }
for I:=1 to KP1 do
 begin
  _FIRST_SEG.elm5[I-1] := AD2Y[(I-1)*M];
_25:
  _FIRST_SEG.elm6[I-1] := AD2Y[1+(I-1)*M];
 end;
{  }
{ --------SAVING COORDINATES AND VELOCITY AT THE END OF 1 INTERVAL }
_FIRST_SEG.elm7[0] := Y[0];
_FIRST_SEG.elm7[1] := Y[1];
_FIRST_SEG.elm8[0] := DY[0];
_FIRST_SEG.elm8[1] := DY[1];
{  }
{ --------SAVING BOUNDARIES OF 1 INTERVAL }
_FIRST_SEG.elm9[0] := XI;
_FIRST_SEG.elm9[1] := XE;
exit;
{  }
{ --------SAVING CHEBYSHEV COEFFICIENTS FOR  COORDINATES, }
{ --------     VELOCITY COMPONENTS AND ACCELERATION COMPONENTS }
{ ------------           AT THE SECOND INTERVAL }
{  };
_30:
for I:=1 to KP3 do
 begin
  _SECOND_SEG.elm1[I-1] := AY[(I-1)*M];
_35:
  _SECOND_SEG.elm2[I-1] := AY[1+(I-1)*M];
 end;
{  }
for I:=1 to KP2 do
 begin
  _SECOND_SEG.elm3[I-1] := ADY[(I-1)*M];
_40:
  _SECOND_SEG.elm4[I-1] := ADY[1+(I-1)*M];
 end;
{  }
for I:=1 to KP1 do
 begin
  _SECOND_SEG.elm5[I-1] := AD2Y[(I-1)*M];
_45:
  _SECOND_SEG.elm6[I-1] := AD2Y[1+(I-1)*M];
 end;
{  }
{ --------SAVING COORDINATES AND VELOCITY AT THE END OF 2 INTERVAL }
_SECOND_SEG.elm7[0] := Y[0];
_SECOND_SEG.elm7[1] := Y[1];
_SECOND_SEG.elm8[0] := DY[0];
_SECOND_SEG.elm8[1] := DY[1];
{  }
{ --------SAVING BOUNDARIES OF 2 INTERVAL }
_SECOND_SEG.elm9[0] := XI;
_SECOND_SEG.elm9[1] := XE;
end;
//******************************************************************
procedure F2TREA3(S :Integer; XI :Extended; XE :Extended;
                var Y :Array of Extended; var DY :Array of Extended;
                var AY :Array of Extended; var ADY :Array of Extended;
                var AD2Y :Array of Extended; M :Integer;
                KP1 :Integer; KP2 :Integer; KP3 :Integer);
var
J :Integer;
HI,X :Extended;
YI :Array [0..1] of Extended;
BK :Array [0..3] of Extended;
label
_10;
begin
HI := (XE-XI)/(_DELTR.elm3);
X := XI;
for J:=1 to _DELTR.elm3 do
 begin
  X := X+HI;
{  }
{ ------CALCULATION OF SOLUTION YI AT POINT X (BY ALGORITHM CLENSHAW, }
{ -------    KP2 - POWER (DEGREE) OF POLYNOMIAL ) }
{  }
  DE70EC(M,KP2,X,AY,YI,BK);
{  }
  _DELTR.elm1[(J-1)+(S-1)*16] := Sqrt(IntPower(YI[0]-3.e0,2)+IntPower(YI[1]-2.e0,2));
  _DELTR.elm2[(J-1)+(S-1)*16] := 1.e0-_DELTR.elm1[(J-1)+(S-1)*16];
_10:
 end;
end;
//************************************************

end.
